Unit IDS1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure IDS1R(N :Integer; var X :Array of Real;
                var Y :Array of Real; var Y2 :Array of Real;
                var F :Array of Real; var G :Array of Real);

implementation

procedure IDS1R(N :Integer; var X :Array of Real;
                var Y :Array of Real; var Y2 :Array of Real;
                var F :Array of Real; var G :Array of Real);
var
K,N1,N2,J1,J2 :Integer;
F1,F2,H1,H2,R1,R2,U,V,Z :Real;
label
_1,_2,_3,_4;
begin
N1 := N-1;
G[0] := 0.0;
F[0] := 0.0;
U := Y2[0];
V := Y2[N-1];
F2 := 2.0;
for K:=1 to N1 do
 begin
  J2 := K+1;
  H2 := X[J2-1]-X[K-1];
  R2 := (Y[J2-1]-Y[K-1])/H2;
  if ( K = 1 ) 
   then goto _1;
  F1 := 2.0;
  if ( K = 2 ) 
   then F1 := 2.0+U;
  if ( K = N1 ) 
   then F2 := 2.0+V;
  Z := 1.0/((F1-G[J1-1])*H1+F2*H2);
  G[K-1] := Z*H2;
  F[K-1] := Z*(6.0*(R2-R1)-H1*F[J1-1]);
_1:
  J1 := K;
  H1 := H2;
  R1 := R2;
_2:
 end;
Y2[N1-1] := F[N1-1];
if ( N1 <= 2 ) 
 then goto _4;
N2 := N1-1;
for J1:=2 to N2 do
 begin
  K := N-J1;
  Y2[K-1] := F[K-1]-G[K-1]*Y2[K+0];
_3:
 end;
_4:
Y2[0] := U*Y2[1];
Y2[N-1] := V*Y2[N1-1];
end;

end.
